﻿// <auto-generated />
using System;
using CASPER.Infrastructure.Persistence;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

#nullable disable

namespace CASPER.Infrastructure.Migrations
{
    [DbContext(typeof(ApplicationDbContext))]
    partial class ApplicationDbContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "7.0.3")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            NpgsqlModelBuilderExtensions.HasPostgresEnum(modelBuilder, "business_services", new[] { "exchange", "custodial", "mining" });
            NpgsqlModelBuilderExtensions.HasPostgresEnum(modelBuilder, "technology_services", new[] { "lightning_network", "coin_merge" });
            NpgsqlModelBuilderExtensions.UseIdentityByDefaultColumns(modelBuilder);

            modelBuilder.Entity("CASPER.Domain.Entities.LegalEntity", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<int[]>("BusinessServices")
                        .IsRequired()
                        .HasColumnType("integer[]");

                    b.Property<DateTime>("CreatedAt")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("timestamp with time zone")
                        .HasDefaultValueSql("NOW() AT TIME ZONE 'UTC'");

                    b.Property<string>("GoverningJurisdiction")
                        .IsRequired()
                        .HasMaxLength(2)
                        .IsUnicode(false)
                        .HasColumnType("character varying(2)");

                    b.Property<DateTime?>("LastUpdatedAt")
                        .ValueGeneratedOnUpdate()
                        .HasColumnType("timestamp with time zone");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(80)
                        .HasColumnType("character varying(80)");

                    b.Property<Guid?>("PaymentProviderId")
                        .HasColumnType("uuid");

                    b.Property<int[]>("TechnologyServices")
                        .IsRequired()
                        .HasColumnType("integer[]");

                    b.Property<Guid?>("VirtualAssetServiceProviderId")
                        .HasColumnType("uuid");

                    b.Property<string>("Website")
                        .IsRequired()
                        .HasColumnType("text");

                    b.HasKey("Id");

                    b.HasIndex("PaymentProviderId");

                    b.HasIndex("VirtualAssetServiceProviderId");

                    b.ToTable("LegalEntities");
                });

            modelBuilder.Entity("CASPER.Domain.Entities.LegalEntityProperty", b =>
                {
                    b.Property<Guid>("LegalEntityId")
                        .HasColumnType("uuid");

                    b.Property<string>("Name")
                        .HasMaxLength(60)
                        .HasColumnType("character varying(60)");

                    b.Property<object>("Content")
                        .HasMaxLength(300)
                        .HasColumnType("json");

                    b.Property<DateTime>("CreatedAt")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("timestamp with time zone")
                        .HasDefaultValueSql("NOW() AT TIME ZONE 'UTC'");

                    b.Property<DateTime?>("LastUpdatedAt")
                        .ValueGeneratedOnUpdate()
                        .HasColumnType("timestamp with time zone");

                    b.HasKey("LegalEntityId", "Name");

                    b.ToTable("LegalEntityProperties");
                });

            modelBuilder.Entity("CASPER.Domain.Entities.PaymentIdentifier", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<DateTime>("CreatedAt")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("timestamp with time zone")
                        .HasDefaultValueSql("NOW() AT TIME ZONE 'UTC'");

                    b.Property<string>("IBAN")
                        .IsRequired()
                        .HasMaxLength(34)
                        .HasColumnType("character varying(34)");

                    b.Property<DateTime?>("LastUpdatedAt")
                        .ValueGeneratedOnUpdate()
                        .HasColumnType("timestamp with time zone");

                    b.Property<Guid?>("PaymentProviderId")
                        .HasColumnType("uuid");

                    b.Property<Guid>("VirtualAssetServiceProviderId")
                        .HasColumnType("uuid");

                    b.HasKey("Id");

                    b.HasIndex("PaymentProviderId");

                    b.HasIndex("VirtualAssetServiceProviderId");

                    b.ToTable("PaymentIdentifiers");
                });

            modelBuilder.Entity("CASPER.Domain.Entities.PaymentProvider", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<string>("Address")
                        .IsRequired()
                        .HasMaxLength(300)
                        .HasColumnType("character varying(300)");

                    b.Property<DateTime>("CreatedAt")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("timestamp with time zone")
                        .HasDefaultValueSql("NOW() AT TIME ZONE 'UTC'");

                    b.Property<DateTime?>("LastUpdatedAt")
                        .ValueGeneratedOnUpdate()
                        .HasColumnType("timestamp with time zone");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(60)
                        .HasColumnType("character varying(60)");

                    b.Property<string>("Website")
                        .IsRequired()
                        .HasMaxLength(120)
                        .HasColumnType("character varying(120)");

                    b.HasKey("Id");

                    b.ToTable("PaymentProviders");
                });

            modelBuilder.Entity("CASPER.Domain.Entities.VirtualAssetServiceProvider", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid");

                    b.Property<string>("Address")
                        .IsRequired()
                        .HasMaxLength(300)
                        .HasColumnType("character varying(300)");

                    b.Property<DateTime>("CreatedAt")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("timestamp with time zone")
                        .HasDefaultValueSql("NOW() AT TIME ZONE 'UTC'");

                    b.Property<DateTime?>("LastUpdatedAt")
                        .ValueGeneratedOnUpdate()
                        .HasColumnType("timestamp with time zone");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(60)
                        .HasColumnType("character varying(60)");

                    b.Property<string>("Website")
                        .IsRequired()
                        .HasMaxLength(120)
                        .HasColumnType("character varying(120)");

                    b.HasKey("Id");

                    b.HasIndex("Website")
                        .IsUnique();

                    b.ToTable("VirtualAssetServiceProviders");
                });

            modelBuilder.Entity("CASPER.Domain.Entities.VirtualAssetServiceProviderProperty", b =>
                {
                    b.Property<Guid>("VirtualAssetServiceProviderId")
                        .HasColumnType("uuid");

                    b.Property<string>("Name")
                        .HasMaxLength(60)
                        .HasColumnType("character varying(60)");

                    b.Property<object>("Content")
                        .HasMaxLength(300)
                        .HasColumnType("json");

                    b.Property<DateTime>("CreatedAt")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("timestamp with time zone")
                        .HasDefaultValueSql("NOW() AT TIME ZONE 'UTC'");

                    b.Property<DateTime?>("LastUpdatedAt")
                        .ValueGeneratedOnUpdate()
                        .HasColumnType("timestamp with time zone");

                    b.HasKey("VirtualAssetServiceProviderId", "Name");

                    b.ToTable("VirtualAssetServiceProviderProperties");
                });

            modelBuilder.Entity("CASPER.Domain.Entities.LegalEntity", b =>
                {
                    b.HasOne("CASPER.Domain.Entities.PaymentProvider", "PaymentProvider")
                        .WithMany("LegalEntities")
                        .HasForeignKey("PaymentProviderId");

                    b.HasOne("CASPER.Domain.Entities.VirtualAssetServiceProvider", "VirtualAssetServiceProvider")
                        .WithMany("LegalEntities")
                        .HasForeignKey("VirtualAssetServiceProviderId");

                    b.Navigation("PaymentProvider");

                    b.Navigation("VirtualAssetServiceProvider");
                });

            modelBuilder.Entity("CASPER.Domain.Entities.LegalEntityProperty", b =>
                {
                    b.HasOne("CASPER.Domain.Entities.LegalEntity", "LegalEntity")
                        .WithMany("Properties")
                        .HasForeignKey("LegalEntityId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("LegalEntity");
                });

            modelBuilder.Entity("CASPER.Domain.Entities.PaymentIdentifier", b =>
                {
                    b.HasOne("CASPER.Domain.Entities.PaymentProvider", "PaymentProvider")
                        .WithMany("PaymentIdentifiers")
                        .HasForeignKey("PaymentProviderId");

                    b.HasOne("CASPER.Domain.Entities.VirtualAssetServiceProvider", "VirtualAssetServiceProvider")
                        .WithMany("PaymentIdentifiers")
                        .HasForeignKey("VirtualAssetServiceProviderId");

                    b.Navigation("PaymentProvider");

                    b.Navigation("VirtualAssetServiceProvider");
                });

            modelBuilder.Entity("CASPER.Domain.Entities.VirtualAssetServiceProviderProperty", b =>
                {
                    b.HasOne("CASPER.Domain.Entities.VirtualAssetServiceProvider", "VirtualAssetServiceProvider")
                        .WithMany("Properties")
                        .HasForeignKey("VirtualAssetServiceProviderId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("VirtualAssetServiceProvider");
                });

            modelBuilder.Entity("CASPER.Domain.Entities.LegalEntity", b =>
                {
                    b.Navigation("Properties");
                });

            modelBuilder.Entity("CASPER.Domain.Entities.PaymentProvider", b =>
                {
                    b.Navigation("LegalEntities");

                    b.Navigation("PaymentIdentifiers");
                });

            modelBuilder.Entity("CASPER.Domain.Entities.VirtualAssetServiceProvider", b =>
                {
                    b.Navigation("LegalEntities");

                    b.Navigation("PaymentIdentifiers");

                    b.Navigation("Properties");
                });
#pragma warning restore 612, 618
        }
    }
}
